HDU 5534 HDU 5532 2015ACM-ICPC长春赛区现场赛H题

Partial Tree

Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 262144/262144 K (Java/Others)
Total Submission(s): 1156 Accepted Submission(s): 579

Problem Description
In mathematics, and more specifically in graph theory, a tree is an undirected graph in which any two nodes are connected by exactly one path. In other words, any connected graph without simple cycles is a tree.

You find a partial tree on the way home. This tree has n nodes but lacks of n−1 edges. You want to complete this tree by adding n−1 edges. There must be exactly one path between any two nodes after adding. As you know, there are nn−2 ways to complete this tree, and you want to make the completed tree as cool as possible. The coolness of a tree is the sum of coolness of its nodes. The coolness of a node is f(d), where f is a predefined function and d is the degree of this node. What’s the maximum coolness of the completed tree?

Input
The first line contains an integer T indicating the total number of test cases.
Each test case starts with an integer n in one line,
then one line with n−1 integers f(1),f(2),…,f(n−1).

1≤T≤2015
2≤n≤2015
0≤f(i)≤10000
There are at most 10 test cases with n>100.

Output
For each test case, please output the maximum coolness of the completed tree in one line.

Sample Input
2
3
2 1
4
5 1 4

Sample Output
5
19

Source
2015ACM/ICPC亚洲区长春站-重现赛(感谢东北师大)

题意
构建一棵n个节点的树,统计每棵树的度数,不同度数有不同价值,问树能构成的最大价值

思路
可以发现树的度是固定的,n个节点的树的度数和是2*n-2,所以可以把这道题看做背包问题,度数即背包容量,在恰好满足背包容量的情况下,使得价值最大,这题就轻松A了

另外,因为每棵树的度数至少要保证>=1,所以可以先将DP方程处理一下

#include<stdio.h>
#include<algorithm>
#include<string.h>
#include<algorithm>
using namespace std;

int f[2020];
int dp[2020];
int main() {
    int T;
    int n;
    scanf("%d", &T);
    while (T--) {
        scanf("%d", &n);
        for (int i = 0; i < n - 1; i++) {
            scanf("%d", &f[i]);
        }
        for (int i = 1; i < n - 1; i++) {
            f[i] = f[i] - f[0];
        }
        memset(dp, 0, sizeof(dp));
        dp[0] = f[0] * n;
        for (int i = 1; i < n - 1; i++) {
            for (int j = i; j < n - 1; j++) {
                dp[j] = max(dp[j], dp[j - i] + f[i]);
            }
        }
        printf("%d\n", dp[n - 2]);
    }
    return 0;
}
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值